"use strict";
/*
 * Copyright (c) 2019., Charlie Tiehm - admin@tiehm.me
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Initialize the event and run it every time its emitted
 * @param event {string} Event name
 */
function On(event) {
    return setMetaData({ once: false, name: event });
}
exports.On = On;
/**
 * Initialize the event and run it once
 * @param event {string} Event name
 */
function Once(event) {
    return setMetaData({ once: true, name: event });
}
exports.Once = Once;
/**
 * Set values to the Event class
 * @param data
 * @private
 */
function setMetaData(data) {
    return function (target) {
        Object.defineProperty(target.prototype, 'eventName', {
            value: data.name,
            configurable: true,
            enumerable: true,
            writable: true,
        });
        Object.defineProperty(target.prototype, 'once', {
            value: data.once,
            configurable: true,
            enumerable: true,
            writable: true,
        });
        return target;
    };
}
exports.setMetaData = setMetaData;
//# sourceMappingURL=EventDecorators.js.map