"use strict";
/*
 * Copyright (c) 2019., Charlie Tiehm - admin@tiehm.me
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const __1 = require("../../");
class CommandRegistry extends discord_js_1.Collection {
    constructor(client) {
        super();
        this.client = client;
    }
    /**
     * This should only be used by external libraries
     * @param command {Command}
     */
    registerExternalCommand(command) {
        this.logger.log(`Loaded external command: ${name}`);
        this.registerInternalCommand(command);
    }
    /**
     * Used for registering commands
     * @private
     * @param command
     */
    registerInternalCommand(command) {
        this.logger.debug(`Internally registering command ${command.commandName}`);
        if (this.get(command.commandName)) {
            this.logger.debug(`Overwriting command ${command.commandName}`);
            this.delete(command.commandName);
        }
        this.set(command.commandName, command);
        command._init(this.client);
    }
}
__decorate([
    __1.logger()
], CommandRegistry.prototype, "logger", void 0);
exports.CommandRegistry = CommandRegistry;
//# sourceMappingURL=CommandRegistry.js.map