"use strict";
/*
 * Copyright (c) 2019., Charlie Tiehm - admin@tiehm.me
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const __1 = require("../../..");
const Command_1 = require("../Command");
let Help = class Help extends Command_1.Command {
    constructor() {
        super(...arguments);
        this.shouldShowCommand = (value, msg) => {
            if (value.ownerOnly && this.client.owner !== msg.author.id)
                return false;
            if (value.minRole) {
                const role = msg.guild.roles.find(r => r.name.toLowerCase() === this.minRole.toLowerCase() ||
                    r.id === this.minRole);
                if (msg.member.highestRole.comparePositionTo(role) < 0) {
                    return false;
                }
            }
            if (value.restricted &&
                (!this.restricted.users.includes(msg.author.id) ||
                    msg.guild && !msg.member.roles.some(r => this.restricted.roles.includes(r.id)))) {
                return false;
            }
            return !(value.userPermissions && !msg.member.hasPermissions(this.userPermissions));
            // tslint:disable-next-line
        };
    }
    run(msg, args) {
        return __awaiter(this, void 0, void 0, function* () {
            if (args.length === 0) {
                const commands = this.client.defaultHelpCommand.showAll ?
                    this.client.commands.filter(value => !value.hidden).map((value) => {
                        return {
                            name: value.commandName,
                            usage: value.usage,
                            desc: value.desc,
                            alias: value.alias
                        };
                    }) :
                    this.client.commands
                        .filter(value => !value.hidden).filter(value => this.shouldShowCommand(value, msg))
                        .map((value) => {
                        return {
                            name: value.commandName,
                            usage: value.usage,
                            desc: value.desc,
                            alias: value.alias
                        };
                    });
                const embed = new discord_js_1.RichEmbed()
                    .setTimestamp()
                    .setTitle('Help')
                    .setColor('#79a8ff')
                    .setFooter('Automatically generated.');
                for (const cmd of commands.sort((a, b) => {
                    if (a.name < b.name)
                        return -1;
                    if (a.name > b.name)
                        return 1;
                    return 0;
                })) {
                    const aliases = cmd.alias.length > 0 ? cmd.alias.join(', ') : 'None';
                    embed.addField(cmd.name, // tslint:disable-next-line
                    `${cmd.desc || ''}\nUsage: \`${this.client.defaultPrefix}${cmd.name} ${cmd.usage}\` \nAlias: \`${aliases}\``, true);
                }
                yield msg.reply(embed);
            }
            else if (args.length === 1) {
                const command = this.client.commands.get(args[0].toLowerCase());
                if (!command) {
                    yield msg.reply('Could not find this command. Use the `help` command to see a list of commands.');
                    return null;
                }
                if (!this.client.defaultHelpCommand.showAll &&
                    (command.hidden || this.shouldShowCommand(command, msg))) {
                    yield msg.reply('You do not have enough permissions to view this command or this command does not exist.');
                    return null;
                }
                // TODO: Make more detailed
                const embed = new discord_js_1.RichEmbed()
                    .setTitle(`Help - ${command.commandName}`)
                    .setTimestamp()
                    .addField('Alias', command.alias.length === 0 ? 'None' : command.alias.join(', '), true)
                    .addField('Description', command.desc || 'No description provided.', true)
                    .addField('Usage', `\`${this.client.defaultPrefix}${command.commandName} ${command.usage}\``, true);
                yield msg.reply(embed);
            }
            else
                return { syntax: true };
            return null;
        });
    }
};
Help = __decorate([
    __1.Name('help'),
    __1.Description('Shows all commands (available to you) or information about one command.'),
    __1.Only('guild'),
    __1.Usage('[command]')
], Help);
exports.Help = Help;
//# sourceMappingURL=help.js.map