import { SilentClient } from '../..';
export declare abstract class Event<S extends SilentClient = SilentClient> {
    /**
     * @property {Object} client
     * @public
     */
    client: S;
    /**
     * @property {String} eventName
     * @public
     */
    eventName: string;
    /**
     * @property {Boolean} once
     * @public
     */
    once: boolean;
    /**
     * Create a new Event
     * @param options
     * @protected
     */
    protected constructor(options?: {
        once: boolean;
        name: string;
    });
    /**
     * Initiate an event
     * @param client {Object}
     * @private
     */
    _init(client: S): void;
    /**
     * Run/Execute an event
     * @param args {*[]}
     */
    abstract run(...args: any[]): any;
}
