"use strict";
/*
 * Copyright (c) 2019., Charlie Tiehm - admin@tiehm.me
 */
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigError_1 = require("../../util/ConfigError");
class Event {
    /**
     * Create a new Event
     * @param options
     * @protected
     */
    constructor(options) {
        if (options) {
            this.once = options.once;
            this.eventName = options.name;
        }
    }
    /**
     * Initiate an event
     * @param client {Object}
     * @private
     */
    _init(client) {
        this.client = client;
        if (!this.eventName)
            throw new ConfigError_1.ConfigError('Cannot initiate Event without a specified name.');
    }
}
exports.Event = Event;
//# sourceMappingURL=Event.js.map