import { Message } from 'discord.js';
import { Command, SilentClient } from '..';
export declare class Listener {
    private readonly logger;
    /**
     * @property {SilentClient} client
     * @private
     * @readonly
     */
    private readonly client;
    /**
     * @property {Boolean} wait
     * @private
     * @readonly
     */
    private readonly wait;
    /**
     *
     * @param client {SilentClient}
     * @param [waitForImplementation=true] {Boolean}
     */
    constructor(client: SilentClient, waitForImplementation?: boolean);
    /**
     * Handle a message event
     * @param msg {Message}
     * @async
     * @public
     */
    handleMessageEvent(msg: Message): Promise<false | void | Message | Message[]>;
    /**
     * Find a command in a message
     * @param msg {Message}
     * @private
     * @returns {Command}
     */
    _findCommandInMessage(msg: Message): Command;
}
